<?php
/**
 * Sample code for GiroCheckout integration of a giropay-ID check
 *
 * @filesource
 * @package Samples
 * @version $Revision: 140 $ / $Date: 2016-05-03 11:16:05 -0300 (Di, 03 Mai 2016) $
 */
require_once '../../GiroCheckout_SDK/GiroCheckout_SDK.php';

/**
 * configuration of the merchants identifier, project and password
 * this information can be found in the GiroCockpit's project settings
 */
$merchantID = 0;        // Your merchant ID (Verkaufer-ID)
$projectID = 0;         // Your project ID (Projekt-ID)
$projectPassword = "";  // Your project password

/* init giropay transaction an parameters */
try {
	$request = new GiroCheckout_SDK_Request('giropayIDCheck');
	$request->setSecret($projectPassword);
	$request->addParam('merchantId',$merchantID)
	        ->addParam('projectId',$projectID)
	        ->addParam('merchantTxId',1234567890)
	        ->addParam('bic','TESTDETT421')
	        ->addParam('urlRedirect','https://www.my-domain.de/girocheckout/redirect.php')
	        ->addParam('urlNotify','https://www.my-domain.de/girocheckout/redirect.php')
	    //the hash field is auto generated by the SDK
	        ->submit();

  print_r( $request ); echo "\n";
  
	/* if transaction succeeded update your local system an redirect the customer */
	if($request->requestHasSucceeded()) {
    $request->getResponseParam('reference');
    $request->getResponseParam('redirect');

    $request->redirectCustomerToPaymentProvider();
	}
	/* if the transaction did not succeed update your local system, get the responsecode and notify the customer */
	else {
    $request->getResponseParam('rc');
    $request->getResponseParam('msg');
    $request->getResponseMessage($request->getResponseParam('rc'),'DE');
  }
}
catch (Exception $e) { echo $e->getMessage(); }